﻿using NXOpen;
using NXOpen.Annotations;
using NXOpen.CAE;
using NXOpen.Drawings;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace BRAC_FORM
{
    public partial class Form3: Form
    {
        string originalTextbox6 = "";
        string originalTextbox7 = "";
        string originalTextbox1 = "";
        public Form3()
        {
            InitializeComponent();
            button6.Enabled = false;
            button1.Visible = false;
            button5.Visible = false;
            button5.Enabled = false;
            button7.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e) ///////////////////////////////// PREVIOUS
        {
            Form2 form2 = new Form2(); // Create an instance of Form1
            form2.Show(); // Show Form1
            this.Hide();  // Hide Form2
        }

        private void button4_Click(object sender, EventArgs e) ///////////////////////////////// NEXT
        {
           
          
        }

        private void button3_Click(object sender, EventArgs e) ///////////////////////////////// INSERT BRACKET
        {
            Session theSession = Session.GetSession();
            Part assemblyPart = (Part)theSession.Parts.Work;

            GlobalVariables.bracketCounter++;

            string D_width = GlobalVariables.PipeDiameter;
            GlobalVariables.Width = textBox6.Text;
            string Width = GlobalVariables.Width;
            string XPos = textBox7.Text;
            string YPos = "10";

            int IntPoint = (int)GlobalVariables.barrelEnd;

            GlobalVariables.BracketPos = textBox1.Text;
            int bracketPos = int.Parse(GlobalVariables.BracketPos);

            double Pos = IntPoint + bracketPos;

            int Forkint = (int)GlobalVariables.forkdistance + 1;
            string Gaffel_W = Forkint.ToString();

            int bracketWidth = int.Parse(Width);

            int Frontint = (int)GlobalVariables.forkpoint1[1]; // FrontPos
            int FrontDif = Math.Abs(IntPoint - Frontint);
            int FrontPOS = bracketPos - bracketWidth / 2 - FrontDif + 9;


            string Gaffel_L = FrontPOS.ToString();


            Point3d position = new Point3d(0.0, Pos, 0.0);
            string partsFolderPath = GlobalVariables.FilePath;
            Class_Add_item addItem = new Class_Add_item();

            addItem.AddPartToAssembly("Lower_bracet_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos + "," + YPos + "," + Gaffel_W + "," + Gaffel_L, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("Upper_brac_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos + "," + YPos, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("Pin_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("M6_Skruv_SAAB.prt", GlobalVariables.bracketCounter, D_width, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("Las_skruv_SAAB.prt", GlobalVariables.bracketCounter, D_width, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("lax_fot_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos, position, partsFolderPath, assemblyPart);
            addItem.AddPartToAssembly("Sat_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos, position, partsFolderPath, assemblyPart);


            addItem.updateAll();
            addItem.HideDatumsAndSketches();

            UI.GetUI().NXMessageBox.Show("Success", NXMessageBox.DialogType.Information, $"Bracket added at {position}.");


            button6.Enabled = true;
            button5.Enabled = true;
            button7.Enabled = true;
            button3.Enabled = false;

            originalTextbox6 = textBox6.Text;
            originalTextbox7 = textBox7.Text;
            originalTextbox1 = textBox1.Text;


        }

        private void button1_Click(object sender, EventArgs e) ////////////////////////// CREATE FORKPOINTS
        {
            
            NXOpen.Session theSession = NXOpen.Session.GetSession();
            NXOpen.Part workPart = theSession.Parts.Work;
            NXOpen.Part displayPart = theSession.Parts.Display;
            NXOpen.Session.UndoMarkId markId1;
            markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

            NXOpen.Assemblies.Component component1 = ((NXOpen.Assemblies.Component)workPart.ComponentAssembly.RootComponent.FindObject($"COMPONENT Pipa_SAAB_{GlobalVariables.bracketCounter} 1"));
            NXOpen.PartLoadStatus partLoadStatus1;
            theSession.Parts.SetWorkComponent(component1, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus1);

            workPart = theSession.Parts.Work; // Pipa_1
            partLoadStatus1.Dispose();
            theSession.SetUndoMarkName(markId1, "Make Work Part");

            Point_UI pointUI = new Point_UI();

            pointUI.Show();
            //int PointCounterValue = Point_UI.GetCounter();
            var points = pointUI.storedPoints;

            List<double[]> pointsList = new List<double[]>();

            // Assign each point's coordinates to the list
            foreach (var kvp in points)
            {
                pointsList.Add(kvp.Value); // Add the coordinates to the list
            }

            GlobalVariables.forkpoint1 = pointsList[0];
            GlobalVariables.forkpoint2 = pointsList[1];



            NXOpen.Session.UndoMarkId markId2;
            markId2 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

            NXOpen.Assemblies.Component nullNXOpen_Assemblies_Component = null;
            NXOpen.PartLoadStatus partLoadStatus2;
            theSession.Parts.SetWorkComponent(nullNXOpen_Assemblies_Component, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus2);

            workPart = theSession.Parts.Work; // assembly1
            partLoadStatus2.Dispose();
            theSession.SetUndoMarkName(markId1, "Make Work Part");

            GlobalVariables.forkdistance = Math.Sqrt(
                Math.Pow(GlobalVariables.forkpoint2[0] - GlobalVariables.forkpoint1[0], 2) +
                Math.Pow(GlobalVariables.forkpoint2[1] - GlobalVariables.forkpoint1[1], 2) +
                Math.Pow(GlobalVariables.forkpoint2[2] - GlobalVariables.forkpoint1[2], 2)
            );
           
        }

        private void button5_Click(object sender, EventArgs e) /////////////////////// ADD FORK
        {
            //////////////// UNSUPRESS FORK
        
            Session theSession = Session.GetSession();
            Part assemblyPart = (Part)theSession.Parts.Work;

            NXOpen.Part workPart = theSession.Parts.Work;//////////////// SELECT PART IN TREE
            NXOpen.Part displayPart = theSession.Parts.Display;
            NXOpen.Session.UndoMarkId markId1;
            markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

            NXOpen.Assemblies.Component component1 = ((NXOpen.Assemblies.Component)workPart.ComponentAssembly.RootComponent.FindObject($"COMPONENT Lower_bracet_SAAB_{GlobalVariables.bracketCounter} 1"));
            NXOpen.PartLoadStatus partLoadStatus1;
            theSession.Parts.SetWorkComponent(component1, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus1);

            workPart = theSession.Parts.Work; // FORKTEST
            partLoadStatus1.Dispose();
            theSession.SetUndoMarkName(markId1, "Make Work Part");


            markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Unsuppress Feature"); ///////////////////////// UNSUPRESS

            NXOpen.Features.Feature[] features1 = new NXOpen.Features.Feature[1];
            NXOpen.Features.FeatureGroup featureGroup1 = ((NXOpen.Features.FeatureGroup)workPart.Features.FindObject("FEATURE_SET(20)"));
            features1[0] = featureGroup1;
            NXOpen.Features.Feature[] errorFeatures1;
            errorFeatures1 = workPart.Features.UnsuppressFeatures(features1);

            markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part"); /////////////////// SELECT TOP ASSEMBLY

            NXOpen.Assemblies.Component nullNXOpen_Assemblies_Component = null;
            NXOpen.PartLoadStatus partLoadStatus2;
            theSession.Parts.SetWorkComponent(nullNXOpen_Assemblies_Component, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus2);

            workPart = theSession.Parts.Work; // assembly1
            partLoadStatus2.Dispose();
            theSession.SetUndoMarkName(markId1, "Make Work Part");
        }

        private void button6_Click(object sender, EventArgs e) ////////////////////// DELETE
        {
            Class_Add_item addItem = new Class_Add_item();

            addItem.DeleteBracket("Lower_bracet_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("Upper_brac_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("Pin_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("M6_Skruv_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("Las_skruv_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("lax_fot_SAAB", GlobalVariables.bracketCounter);
            addItem.DeleteBracket("Sat_SAAB", GlobalVariables.bracketCounter);
           // addItem.DeleteBracket("Pipa_SAAB", GlobalVariables.pipeCounter);

            UI.GetUI().NXMessageBox.Show("Success", NXMessageBox.DialogType.Information, $"Bracket was removed from assembly");

            button6.Enabled = false;
            button3.Enabled = true;
        }

        private void checkBox1_CheckedChanged_1(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                button1.Visible = true;
                button5.Visible = true; // Show the button
            }
            else
            {
                button1.Visible = false; // Hide the button again (optional)
                button5.Visible = false; // Hide the button again (optional)
            }
        }

        private void button7_Click(object sender, EventArgs e) /////////////////////////// UPDATE
        {
            if (textBox6.Text != originalTextbox6 & textBox1.Text == originalTextbox1 || textBox7.Text != originalTextbox7 & textBox1.Text == originalTextbox1)
            {
                //////////////// SELECT PART IN TREE

                Session theSession = Session.GetSession();
                Part assemblyPart = (Part)theSession.Parts.Work;

                NXOpen.Part workPart = theSession.Parts.Work;
                NXOpen.Part displayPart = theSession.Parts.Display;
                NXOpen.Session.UndoMarkId markId1;
                markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component component1 = ((NXOpen.Assemblies.Component)workPart.ComponentAssembly.RootComponent.FindObject($"COMPONENT Lower_bracet_SAAB_{GlobalVariables.bracketCounter} 1"));
                NXOpen.PartLoadStatus partLoadStatus1;
                theSession.Parts.SetWorkComponent(component1, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus1);

                workPart = theSession.Parts.Work;
                partLoadStatus1.Dispose();
                theSession.SetUndoMarkName(markId1, "Make Work Part");

                /////////////////// UPDATE EXPRESSION

                NXOpen.Session.UndoMarkId markId2;
                markId2 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Edit Expression");

                NXOpen.Expression expression1 = ((NXOpen.Expression)workPart.Expressions.FindObject("Width"));
                NXOpen.Unit unit1 = ((NXOpen.Unit)workPart.UnitCollection.FindObject("MilliMeter"));
                workPart.Expressions.EditWithUnits(expression1, unit1, textBox6.Text);

                int nErrs1;
                nErrs1 = theSession.UpdateManager.DoUpdate(markId2);

                /////////////////// SELECT TOP ASSEMBLY

                markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component nullNXOpen_Assemblies_Component1 = null;
                NXOpen.PartLoadStatus partLoadStatusx;
                theSession.Parts.SetWorkComponent(nullNXOpen_Assemblies_Component1, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatusx);

                workPart = theSession.Parts.Work;
                partLoadStatusx.Dispose();
                theSession.SetUndoMarkName(markId1, "Make Work Part");

            

                //////////////// SELECT PART IN TREE

                NXOpen.Session.UndoMarkId markId3;
                markId3 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component component2 = ((NXOpen.Assemblies.Component)workPart.ComponentAssembly.RootComponent.FindObject($"COMPONENT lax_fot_SAAB_{GlobalVariables.bracketCounter} 1"));
                NXOpen.PartLoadStatus partLoadStatus2;
                theSession.Parts.SetWorkComponent(component2, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus2);

                workPart = theSession.Parts.Work;
                partLoadStatus2.Dispose();
                theSession.SetUndoMarkName(markId3, "Make Work Part");

                /////////////////// UPDATE EXPRESSION

                NXOpen.Session.UndoMarkId markId4;
                markId4 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Edit Expression");

                NXOpen.Expression expression2 = ((NXOpen.Expression)workPart.Expressions.FindObject("X_pos"));
                NXOpen.Unit unit2 = ((NXOpen.Unit)workPart.UnitCollection.FindObject("MilliMeter"));
                workPart.Expressions.EditWithUnits(expression2, unit2, textBox7.Text);

                int nErrs2;
                nErrs2 = theSession.UpdateManager.DoUpdate(markId4);

                /////////////////// UPDATE EXPRESSION

                NXOpen.Session.UndoMarkId markId5;
                markId5 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Edit Expression");

                NXOpen.Expression expression3 = ((NXOpen.Expression)workPart.Expressions.FindObject("Width"));
                NXOpen.Unit unit3 = ((NXOpen.Unit)workPart.UnitCollection.FindObject("MilliMeter"));
                workPart.Expressions.EditWithUnits(expression3, unit3, textBox6.Text);

                int nErrs3;
                nErrs3 = theSession.UpdateManager.DoUpdate(markId5);

                /////////////////// SELECT TOP ASSEMBLY

                markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component nullNXOpen_Assemblies_Component = null;
                NXOpen.PartLoadStatus partLoadStatus;
                theSession.Parts.SetWorkComponent(nullNXOpen_Assemblies_Component, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus);

                workPart = theSession.Parts.Work;
                partLoadStatus.Dispose();
                theSession.SetUndoMarkName(markId1, "Make Work Part");

                //////////////// SELECT PART IN TREE
                NXOpen.Session.UndoMarkId markId6;
                markId6 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component component3 = ((NXOpen.Assemblies.Component)workPart.ComponentAssembly.RootComponent.FindObject($"COMPONENT Sat_SAAB_{GlobalVariables.bracketCounter} 1"));
                NXOpen.PartLoadStatus partLoadStatus3;
                theSession.Parts.SetWorkComponent(component3, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus3);

                workPart = theSession.Parts.Work;
                partLoadStatus3.Dispose();
                theSession.SetUndoMarkName(markId6, "Make Work Part");

                /////////////////// UPDATE EXPRESSION

                NXOpen.Session.UndoMarkId markId7;
                markId7 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Edit Expression");

                NXOpen.Expression expression4 = ((NXOpen.Expression)workPart.Expressions.FindObject("X_pos"));
                NXOpen.Unit unit4 = ((NXOpen.Unit)workPart.UnitCollection.FindObject("MilliMeter"));
                workPart.Expressions.EditWithUnits(expression4, unit4, textBox7.Text);

                int nErrs4;
                nErrs4 = theSession.UpdateManager.DoUpdate(markId7);

                /////////////////// SELECT TOP ASSEMBLY

                markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Make Work Part");

                NXOpen.Assemblies.Component nullNXOpen_Assemblies_Component2 = null;
                NXOpen.PartLoadStatus partLoadStatus8;
                theSession.Parts.SetWorkComponent(nullNXOpen_Assemblies_Component2, NXOpen.PartCollection.RefsetOption.Entire, NXOpen.PartCollection.WorkComponentOption.Visible, out partLoadStatus8);

                workPart = theSession.Parts.Work;
                partLoadStatus8.Dispose();
                theSession.SetUndoMarkName(markId1, "Make Work Part");

                originalTextbox6 = textBox6.Text;

                originalTextbox7 = textBox7.Text;



                UI.GetUI().NXMessageBox.Show("Success", NXMessageBox.DialogType.Information, $"Parameters were updated.");
            }
            if (textBox1.Text != originalTextbox1)
            {
                Class_Add_item addItem = new Class_Add_item();

                addItem.DeleteBracket("Lower_bracet_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("Upper_brac_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("Pin_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("M6_Skruv_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("Las_skruv_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("lax_fot_SAAB", GlobalVariables.bracketCounter);
                addItem.DeleteBracket("Sat_SAAB", GlobalVariables.bracketCounter);

                Session theSession = Session.GetSession();
                Part assemblyPart = (Part)theSession.Parts.Work;

                GlobalVariables.bracketCounter++;

                string D_width = GlobalVariables.PipeDiameter;
                GlobalVariables.Width = textBox6.Text;
                string Width = GlobalVariables.Width;
                string XPos = textBox7.Text;
                string YPos = "10";

                int IntPoint = (int)GlobalVariables.barrelEnd;

                GlobalVariables.BracketPos = textBox1.Text;
                int bracketPos = int.Parse(GlobalVariables.BracketPos);

                double Pos = IntPoint + bracketPos;

                int Forkint = (int)GlobalVariables.forkdistance + 1;
                string Gaffel_W = Forkint.ToString();

                int bracketWidth = int.Parse(Width);

                int Frontint = (int)GlobalVariables.forkpoint1[1]; // FrontPos
                int FrontDif = Math.Abs(IntPoint - Frontint);
                int FrontPOS = bracketPos - bracketWidth / 2 - FrontDif + 9;


                string Gaffel_L = FrontPOS.ToString();


                Point3d position = new Point3d(0.0, Pos, 0.0);
                string partsFolderPath = GlobalVariables.FilePath;
                

                addItem.AddPartToAssembly("Lower_bracet_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos + "," + YPos + "," + Gaffel_W + "," + Gaffel_L, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("Upper_brac_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos + "," + YPos, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("Pin_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("M6_Skruv_SAAB.prt", GlobalVariables.bracketCounter, D_width, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("Las_skruv_SAAB.prt", GlobalVariables.bracketCounter, D_width, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("lax_fot_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos, position, partsFolderPath, assemblyPart);
                addItem.AddPartToAssembly("Sat_SAAB.prt", GlobalVariables.bracketCounter, D_width + "," + Width + "," + XPos, position, partsFolderPath, assemblyPart);


                addItem.updateAll();
                addItem.HideDatumsAndSketches();

                originalTextbox6 = textBox6.Text;
                originalTextbox7 = textBox7.Text;
                originalTextbox1 = textBox1.Text;


                UI.GetUI().NXMessageBox.Show("Success", NXMessageBox.DialogType.Information, $"Parameters were updated.");
            }
            
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Session theSession = Session.GetSession();
            Part workPart = theSession.Parts.Work;
            Part displayPart = theSession.Parts.Display;

            // Skapa assemblyritning
            FileNew fileNew1 = theSession.Parts.FileNew();
            fileNew1.TemplateFileName = "Drawing-A3-Size-template.prt";
            fileNew1.UseBlankTemplate = false;
            fileNew1.ApplicationName = "DrawingTemplate";
            fileNew1.Units = Part.Units.Millimeters;
            fileNew1.UsesMasterModel = "Yes";
            fileNew1.TemplateType = FileNewTemplateType.Item;
            fileNew1.TemplatePresentationName = "A3 - Size";
            fileNew1.NewFileName = @"C:\\Users\\hanli255\\source\\repos\\from-weapon-brac\\BRAC_FORM\\CAD\\assembly1_dwg1.prt";
            fileNew1.MasterFileName = "assembly1";


            fileNew1.MakeDisplayedPart = true;
            fileNew1.DisplayPartOption = DisplayPartOption.AllowAdditional;
            fileNew1.Commit();
            fileNew1.Destroy();


            workPart = theSession.Parts.Work;
            workPart.Drafting.EnterDraftingApplication();
            workPart.Drafting.SetTemplateInstantiationIsComplete(true);

            // === FRONT ===+++
            BaseViewBuilder frontBuilder = workPart.DraftingViews.CreateBaseViewBuilder(null);
            frontBuilder.SelectModelView.SelectedView = workPart.ModelingViews.FindObject("Front") as ModelingView;
            frontBuilder.Placement.Placement.SetValue(null, workPart.Views.WorkView, new Point3d(100, 100, 0));
            frontBuilder.Scale.Denominator = 3.0; ///skalan!
            BaseView frontView = (BaseView)frontBuilder.Commit();
            frontBuilder.Destroy();

            // === RIGHT ===
            BaseViewBuilder rightBuilder = workPart.DraftingViews.CreateBaseViewBuilder(null);
            rightBuilder.SelectModelView.SelectedView = workPart.ModelingViews.FindObject("Right") as ModelingView;
            rightBuilder.Placement.Placement.SetValue(frontView, workPart.Views.WorkView, new Point3d(220, 100, 0));
            rightBuilder.Scale.Denominator = 3.0;//skalan!
            BaseView rightView = (BaseView)rightBuilder.Commit();
            rightBuilder.Destroy();

            // === ISOMETRIC ===
            BaseViewBuilder isoBuilder = workPart.DraftingViews.CreateBaseViewBuilder(null);
            isoBuilder.SelectModelView.SelectedView = workPart.ModelingViews.FindObject("Isometric") as ModelingView;
            isoBuilder.Placement.Placement.SetValue(null, workPart.Views.WorkView, new Point3d(210, 200, 0));
            isoBuilder.Scale.Denominator = 3.0;//skalan!
            BaseView isoView = (BaseView)isoBuilder.Commit();
            isoBuilder.Destroy();

            // Parts list
            PlistBuilder plistBuilder = workPart.Annotations.PartsLists.CreatePartsListBuilder(null);
            plistBuilder.Origin.Plane.PlaneMethod = NXOpen.Annotations.PlaneBuilder.PlaneMethodType.XyPlane;
            plistBuilder.Contents.TopLevelAssembly = NXOpen.Annotations.PartsListContentsBuilder.TopLevelAssemblyType.ChildPart;
            plistBuilder.Origin.Origin.SetValue(null, null, new Point3d(300, 270, 0));
            plistBuilder.Commit();
            plistBuilder.Destroy();

            HideDatumsAndSketches1();
            // === Skapa separata detaljritningar i nya NX-fönster ===
            CreateSeparateDetailDrawing("Upper_brac_SAAB_1");
            HideDatumsAndSketches1();
            CreateSeparateDetailDrawing("Lower_bracet_SAAB_1");
            CreateSeparateDetailDrawing("M6_skruv_SAAB_1");
            CreateSeparateDetailDrawing("Las_skruv_SAAB_1");
            

            MessageBox.Show("Alla ritningar skapade!");
            GetUnloadOption("hej");
            //theSession.ApplicationSwitchImmediate("UG_APP_MODELING"); Denna ska fixa saker men fixar inget


        }

        private void CreateSeparateDetailDrawing(string partName)
        {
            Session theSession = Session.GetSession();
            string baseDir = @"C:\Users\hanli255\source\repos\from-weapon-brac\BRAC_FORM\CAD\";
            string partPath = baseDir + partName + ".prt";
            string drawingPath = baseDir + partName + "_dwg1.prt";




            Part detailPart = null;

            foreach (Part p in theSession.Parts.ToArray())
            {
                if (p.FullPath.ToLower() == partPath.ToLower())
                {
                    detailPart = p;
                    break;
                }
            }

            if (detailPart == null)
            {
                PartLoadStatus loadStatus;
                detailPart = theSession.Parts.OpenDisplay(partPath, out loadStatus);
                loadStatus.Dispose();
            }

            FileNew fileNew = theSession.Parts.FileNew();
            fileNew.TemplateFileName = "Drawing-A3-Size-template.prt";
            fileNew.TemplatePresentationName = "A3 - Size";
            fileNew.TemplateType = FileNewTemplateType.Item;
            fileNew.ApplicationName = "DrawingTemplate";
            fileNew.Units = Part.Units.Millimeters;
            fileNew.NewFileName = drawingPath;
            fileNew.MasterFileName = partPath;
            fileNew.UseBlankTemplate = false;
            fileNew.MakeDisplayedPart = true;
            fileNew.DisplayPartOption = DisplayPartOption.AllowAdditional;
            fileNew.Commit();
            fileNew.Destroy();

            Part drawingPart = theSession.Parts.Work;
            drawingPart.Drafting.EnterDraftingApplication();
            drawingPart.Drafting.SetTemplateInstantiationIsComplete(true);

            ModelingView front = drawingPart.ModelingViews.FindObject("Front") as ModelingView;
            ModelingView right = drawingPart.ModelingViews.FindObject("Right") as ModelingView;
            ModelingView iso = drawingPart.ModelingViews.FindObject("Isometric") as ModelingView;

            BaseViewBuilder frontBuilder = drawingPart.DraftingViews.CreateBaseViewBuilder(null);
            frontBuilder.SelectModelView.SelectedView = front;
            frontBuilder.Placement.Placement.SetValue(null, drawingPart.Views.WorkView, new Point3d(100, 100, 0));
            BaseView frontView = (BaseView)frontBuilder.Commit();
            frontBuilder.Destroy();

            BaseViewBuilder rightBuilder = drawingPart.DraftingViews.CreateBaseViewBuilder(null);
            rightBuilder.SelectModelView.SelectedView = right;
            rightBuilder.Placement.Placement.SetValue(frontView, drawingPart.Views.WorkView, new Point3d(220, 100, 0));
            BaseView rightView = (BaseView)rightBuilder.Commit();
            rightBuilder.Destroy();

            BaseViewBuilder isoBuilder = drawingPart.DraftingViews.CreateBaseViewBuilder(null);
            isoBuilder.SelectModelView.SelectedView = iso;
            isoBuilder.Placement.Placement.SetValue(null, drawingPart.Views.WorkView, new Point3d(250, 210, 0));
            BaseView isoView = (BaseView)isoBuilder.Commit();
            isoBuilder.Destroy();
            GetUnloadOption("hej");
        }
        public static int GetUnloadOption(string dummy)
        {
            return (int)NXOpen.Session.LibraryUnloadOption.Immediately;

        }
        // === Måttsättning för Lower_brac_Picatinny_1 ===
        // Mått 1: Höjd (t.ex. 31.8 mm)
        //AddDimensionBetweenCurves(115, 85, drawingPart, 1, 2, frontView);

        // Mått 2: Total höjd (t.ex. 37.2 mm)
        //AddDimensionBetweenCurves(115, 50, drawingPart, 2, 3, frontView);

        // === Måttsättning för Upper_brac_Picatinny_1 ===
        // Mått 1: Spårhöjd (t.ex. 0.51 mm)
        //AddDimensionBetweenCurves(115, 55, drawingPart, 1, 2, frontView);

        // Mått 2: Totalhöjd (t.ex. 5.33 mm)
        //AddDimensionBetweenCurves(115, 90, drawingPart, 2, 3, frontView);


        private void AddDimensionBetweenCurves(
    double posX,
    double posY,
    Part part,
    int curveIndex1,
    int curveIndex2,
    BaseView view)
        {
            RapidDimensionBuilder dimBuilder = part.Dimensions.CreateRapidDimensionBuilder(null);
            dimBuilder.Driving.DrivingMethod = DrivingValueBuilder.DrivingValueMethod.Reference;

            // Hämta kurvorna i den valda vyn
            DraftingBody body = view.DraftingBodies.ToArray()[0];
            DraftingCurve curve1 = body.DraftingCurves.ToArray()[curveIndex1 - 1];
            DraftingCurve curve2 = body.DraftingCurves.ToArray()[curveIndex2 - 1];

            // Dummy positions (krävs men används inte eftersom vi ställer in riktig origin)ss
            Point3d dummy = new Point3d(0, 0, 0);

            // Plats där dimensionen ska hamna
            Point3d dimensionLocation = new Point3d(posX, posY, 0);

            // Sätt associeringar
            dimBuilder.FirstAssociativity.SetValue(InferSnapType.SnapType.End, curve1, view, dummy, null, null, dummy);
            dimBuilder.SecondAssociativity.SetValue(InferSnapType.SnapType.End, curve2, view, dummy, null, null, dummy);

            // 🔧 Manuell position
            dimBuilder.Origin.SetInferRelativeToGeometry(false);
            dimBuilder.Origin.Origin.SetValue(null, null, dimensionLocation);

            dimBuilder.Commit();
            dimBuilder.Destroy();
        }
        public void HideDatumsAndSketches1()
        {
            NXOpen.Session theSession = NXOpen.Session.GetSession();
            NXOpen.Part workPart = theSession.Parts.Work;
            NXOpen.Part displayPart = theSession.Parts.Display;
            // ----------------------------------------------
            //   Menu: Edit->Show and Hide->Show and Hide...
            // ----------------------------------------------
            NXOpen.Session.UndoMarkId markId1;
            markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Start");

            theSession.SetUndoMarkName(markId1, "Show and Hide Dialog");

            NXOpen.Session.UndoMarkId markId2;
            markId2 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Hide Sketches");

            int numberHidden1;
            numberHidden1 = theSession.DisplayManager.HideByType("SHOW_HIDE_TYPE_SKETCHES", NXOpen.DisplayManager.ShowHideScope.AnyInAssembly);

            int nErrs1;
            nErrs1 = theSession.UpdateManager.DoUpdate(markId2);

            workPart.Views.WorkView.FitAfterShowOrHide(NXOpen.View.ShowOrHideType.HideOnly);

            NXOpen.Session.UndoMarkId markId3;
            markId3 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Hide Datums");

            int numberHidden2;
            numberHidden2 = theSession.DisplayManager.HideByType("SHOW_HIDE_TYPE_DATUMS", NXOpen.DisplayManager.ShowHideScope.AnyInAssembly);

            int nErrs2;
            nErrs2 = theSession.UpdateManager.DoUpdate(markId3);

            workPart.Views.WorkView.FitAfterShowOrHide(NXOpen.View.ShowOrHideType.HideOnly);

            NXOpen.Session.UndoMarkId markId4;
            markId4 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Hide Points");

            int numberHidden3;
            numberHidden3 = theSession.DisplayManager.HideByType("SHOW_HIDE_TYPE_POINTS", NXOpen.DisplayManager.ShowHideScope.AnyInAssembly);

            int nErrs3;
            nErrs3 = theSession.UpdateManager.DoUpdate(markId4);

            workPart.Views.WorkView.FitAfterShowOrHide(NXOpen.View.ShowOrHideType.HideOnly);

            theSession.SetUndoMarkName(markId1, "Show and Hide");

            theSession.DeleteUndoMark(markId1, null);

            // ----------------------------------------------
            //   Menu: Edit->View->Update...
            // ----------------------------------------------
            NXOpen.Session.UndoMarkId markId5;
            markId5 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Start");

            NXOpen.Drawings.UpdateViewsBuilder updateViewsBuilder1;
            updateViewsBuilder1 = workPart.DraftingViews.CreateUpdateViewsBuilder();

            theSession.SetUndoMarkName(markId5, "Update Views Dialog");

            NXOpen.Drawings.BaseView baseView1 = ((NXOpen.Drawings.BaseView)workPart.DraftingViews.FindObject("Front@1"));
            bool added1;
            added1 = updateViewsBuilder1.Views.Add(baseView1);

            NXOpen.Drawings.BaseView baseView2 = ((NXOpen.Drawings.BaseView)workPart.DraftingViews.FindObject("Right@2"));
            bool added2;
            added2 = updateViewsBuilder1.Views.Add(baseView2);

            NXOpen.Drawings.BaseView baseView3 = ((NXOpen.Drawings.BaseView)workPart.DraftingViews.FindObject("Isometric@3"));
            bool added3;
            added3 = updateViewsBuilder1.Views.Add(baseView3);

            NXOpen.Session.UndoMarkId markId6;
            markId6 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Invisible, "Update Views");

            theSession.DeleteUndoMark(markId6, null);

            NXOpen.Session.UndoMarkId markId7;
            markId7 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Invisible, "Update Views");

            NXOpen.NXObject nXObject1;
            nXObject1 = updateViewsBuilder1.Commit();

            theSession.DeleteUndoMark(markId7, null);

            theSession.SetUndoMarkName(markId5, "Update Views");

            updateViewsBuilder1.Destroy();

        }
    }
}
